Dictionary Name:   ESO-VLT-DIC.TPL
Scope:             DFS
Source:            ESO DICB
Version Control:   "@(#) Id: ESO-VLT-DIC.TPL,v 1.9 2003/06/03 09:51:33 vltsccm Exp $"
Revision:          0.1
Date:              1997-06-01T17:14
Status:            draft
Description:       As proposed by jknudstr/amchavan/eallaert
Revision:          1.0
Date:              1997-09-25
Status:            Released
Description:       Reviewed by DICB
Revision:          1.1
Date:              1999-07-22
Status:            Released
Description:       configuration control: cmm 
Revision:          1.4
Date:              1999-10-14
Status:            Released
Description:       added TPL START 
Revision:          1.5
Date:              2000-04-04
Status:            Released
Description:       added TPL FILE DIRNAME and TPL FILE KEEP 
Revision:          1.7
Date:              2001-04-24
Status:            Released
Description:       added TPL EXEC * ops-log keywords 
Revision:          1.8
Date:              2001-08-10
Status:            Released
Description:       fixed potential installation problem on Solaris 
Revision:          1.9
Date:              2003-06-03
Status:            Released
Description:       increased the length of TPL.NAME and TPL.ID to 47 chars 

Parameter Name:    TPL DID
Class:             header
Context:           template
Type:              string
Value Format:      %30s
Unit:              
Comment Field:     Data dictionary for TPL
Description:       Name and version of ESO DID to which TPL keywords
                   comply to.

Parameter Name:    TPL ID
Class:             header|template|ops-log
Context:           template
Type:              string
Value Format:      %47s
Unit:              
Comment Field:     Template signature ID
Description:	   Unique ID for this template 
                   IDs are constructed according to the following convention:
                        <context>/<name>/<version>
                   where <context> is typically the instrument name
                   (e.g. UVES), <name> is the Template short name (e.g. IOT021)
                   and <version> gives the version number of the template
                   when applicable (e.g. 1.0)
                   Example: "ISAAC/IOT021/1.0.3"

Parameter Name:    TPL NAME
Class:             header|template|ops-log
Context:           template
Type:              string
Value Format:      %47s
Unit:              
Comment Field:     Template name
Description:	   Name for this template

Parameter Name:    TPL NEXP
Class:             header|template
Context:           template
Type:              integer
Value Format:      %d
Unit:              
Comment Field:     Number of exposures within template
Description:	   Total number of exposures defined in the template; this
                   is the sum of SEQ.NEXPO and the number of 'hardcoded'
                   exposures in the template. It must be set properly by
                   the template script, otherwise it will result in 1 as
                   default.

Parameter Name:    TPL EXPNO
Class:             header|template
Context:           template
Type:              integer
Value Format:      %d
Unit:              
Comment Field:     Exposure number within template
Description:	   The number of this exposure within the template, starting
                   at 1 for the first exposure.

Parameter Name:    TPL INSTRUM
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Instrument this template is for
Description:	   The name of the instrument for which this template has
                   been written.

Parameter Name:    TPL MODE
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Mode of observation for this template
Description:	   The mode of observation this template is written for.

Parameter Name:    TPL VERSION
Class:             header|template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Version of the template
Description:	   The version number of this template.

Parameter Name:    TPL REFSUP
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Reference Setup File
Description:	   The name of the reference set-up file that goes together 
                   with this template.  This reflects the mode of observation.
                   It implies that the template gives a 'SETUP -file' command 
                   with this reference set-up file as argument.

Parameter Name:    TPL PRESEQ
Class:             header|template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Sequencer script
Description:	   Name of the Sequencer script file which contains the script 
                   to be executed on the VLT Control Software side when the
                   template gets invoked; in that sense the word
                   'template' is frequently used as a synonym for the script
                   itself, although strictly speaking it is only one of the
                   components of the 'template object'.

Parameter Name:    TPL GUI
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Template GUI panel
Description:	   Name of the GUI panel, to modify template parameters.  If
                   this name is not specified, P2PP will automatically 
                   generate an alternative GUI to edit the template parameters,
                   based on their description in the template signature file.

Parameter Name:    TPL TYPE
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     type of template (science,...)
Description:	   The type of this particular template; must be either
                   'science', 'calib', 'acquisition', 'test' or 'generic'.

Parameter Name:    TPL EXECTIME
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Expected execution time
Description:	   This is the time (in seconds) a template is expected to
                   need from start to finish.  It is either a number or the
                   word 'computed'.  In the latter case, the expected 
                   execution time is computed according to a standard
                   algorithm; this requires the template to have one of 
                   a number of specific parameter combinations - see the
                   documentation of the Template::executionTime method.

Parameter Name:    TPL RESOURCES
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Required resources
Description:	   This is the list of configurable resources used by the
                   template, i.e. the list of all optical elements in the
                   light path which can be physically removed or replaced by
                   another element.
                   This list will be used for scheduling purposes (either to
                   filter out the configuration needed to perform a set of 
                   Observation Blocks, or to check the compatibility of the 
                   current configuration with the one required for a 
                   particular OB).
                   This list is a set of white-space separated words. Each
                   word can be given explicitly as an optical component name
                   (e.g. grating#4) or indirectly as a hierarchical parameter
                   name (e.g. INS.FILT2.NAME)

Parameter Name:    TPL PARAM
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:              
Comment Field:     Next template parameter
Description:	   This introduces the description of a template parameter.
                   Its value has the form <category>.<name>, e.g. 
                   'DET.READOUTMODE'.  
                   The <category> part identifies where
                   the parameter belongs to; allowed values are 'TEL', 'DET',
                   'INS' and 'SEQ' for telescope, detector, instrument set-up
                   resp. Sequencer script.
                   The <name> part defines the parameter name.  It must
                   be a name appearing in one of the dictionaries approved
                   by the Data Interface Control Board.

Parameter Name:    TPL START
Class:             header|template
Context:           template
Type:              string
Value Format:      %19s
Unit:             
Comment Field:     TPL start time 
Description:       exact start time in ISO format, precise up to the second,
                   of the current template of which this exposure is part.
                   Example: 1999-10-15T14:15:59
                   
Parameter Name:    TPL FILE DIRNAME
Class:             template
Context:           template
Type:              string
Value Format:      %s
Unit:             
Comment Field:     Storage filename 
Description:       The value of this keyword shows the absolute pathname of
                   the directory in which the parameter of type "paramfile" 
                   will be stored as a file. 
                   The complete pathname for the disk file will be constructed
                   by appending a forward slash ("/") and then the value of 
                   the PAF.NAME keyword (within the string assigned to a 
                   paramfile parameter) to the value of this keyword; in other
                   words, the pathname to use is decided by the OP tool and is
                   written within the file itself. 
                   Environment variables will be resolved by BOB at run time.
                   For instance: if this keyword is set to the value
                   $VLTROOT/System/tmp, and PAF.NAME is myfile.adp, and the 
                   VLTROOT environment variable is set to /vlt/OCT99, the text
                   file will be created as: /vlt/OCT99/System/tmp/myfile.adp 

Parameter Name:    TPL FILE KEEP
Class:             template
Context:           template
Type:              logical
Value Format:      %c
Unit:             
Comment Field:     paramfile keep-flag 
Description:       This is an optional keyword, used in the context of 
                   paramfile parameters (see also the TPL FILE DIRNAME 
                   keyword).  It is a boolean, indicating whether the file
                   needs to be kept (because it may be needed by subsequent 
                   OBs). In the absence of this keyword, or if it is set to
                   "F", BOB will delete this file as soon as the OB finishes.
                   If this keyword is set to "T", BOB will not do any file
                   clean-up, shifting this responsibility then to the user or
                   operator.

Parameter Name:    TPL EXEC START
Class:             ops-log
Context:           template
Type:              string
Value Format:      %s
Unit:             
Comment Field:     Template execution started 
Description:       Execution of template started.

Parameter Name:    TPL EXEC STOP
Class:             ops-log
Context:           template
Type:              string
Value Format:      %s
Unit:             
Comment Field:     Template execution ended 
Description:       Execution of template ended successfully.

Parameter Name:    TPL EXEC ABORT
Class:             ops-log
Context:           template
Type:              string
Value Format:      %s
Unit:             
Comment Field:     template execution aborted
Description:       Execution of template aborted programmatically or
                   due to error.

Parameter Name:    TPL CHANGE
Class:             ops-log
Context:           template
Type:              string
Value Format:      %s
Unit:             
Comment Field:     template parameters have been edited
Description:       The template editor has been running on this template's 
                   parameters.

# --- oOo ---



