package org.eso.gasgano.gui;

import java.awt.Component;
import java.util.EventObject;
import java.util.Vector;

import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.event.CellEditorListener;
import javax.swing.event.ChangeEvent;
import javax.swing.table.TableCellEditor;


/**
 * @author nkornwei
 *
 * This is a table cell editor that is used by many of the property editing panels
 * for the property editor. 
 * TODO: find out what this editor does and why it is useful - it may no longer be
 * required and can be removed....
 */
public class PropertyCellEditor extends JTextField implements TableCellEditor {
    protected Vector listeners;
    protected String originalValue;

    public PropertyCellEditor() {
        super();
        listeners = new Vector();
    }

    public Component getTableCellEditorComponent(
        JTable table,
        Object value,
        boolean isSelected,
        int row,
        int column) {
        if (value != null) {
            setText((String) value);
        }
        originalValue = getText();
        return this;
    }

    public void cancelCellEditing() {
        fireEditingCanceled();
    }
    public boolean isCellEditable(EventObject eo) {
        return true;
    }
    public Object getCellEditorValue() {
        return new String(getText());
    }
    public boolean shouldSelectCell(EventObject eo) {
        return true;
    }
    public boolean stopCellEditing() {
        fireEditingStopped();
        return true;
    }

    public void addCellEditorListener(CellEditorListener cel) {
        listeners.addElement(cel);
    }

    public void removeCellEditorListener(CellEditorListener cel) {
        listeners.removeElement(cel);
    }

    protected void fireEditingCanceled() {
        setText(originalValue);
        ChangeEvent ce = new ChangeEvent(this);
        for (int i = listeners.size() - 1; i >= 0; i--) {
            ((CellEditorListener) listeners.elementAt(i)).editingCanceled(ce);
        }
    }

    protected void fireEditingStopped() {
        ChangeEvent ce = new ChangeEvent(this);
        for (int i = listeners.size() - 1; i >= 0; i--) {
            ((CellEditorListener) listeners.elementAt(i)).editingStopped(ce);
        }
    }
}
