/*
 * Created by amchavan on Jul 14, 2005
 */
package org.eso.ohs.core.gui.widgets.examples;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Enumeration;

import javax.swing.JButton;
import javax.swing.JComponent;
import javax.swing.JFrame;

import org.eso.ohs.core.gui.widgets.OHSWizard;


/**
 * Example wizard: implements a simple installer-like GUI.
 * 
 * @version $Revision: 1.2 $
 * @author amchavan, Jul 14, 2005
 */

// $Id: InstallerWizard.java,v 1.2 2005/10/07 08:49:56 pnunes Exp $
public class InstallerWizard extends OHSWizard implements ActionListener {

    private static InstallerWizard wiz;

    public InstallerWizard() {
        addPage( new InstallerPage1( this ));
        addPage( new InstallerPage2( this ) );
        addPage( new InstallerPage3( this ) );
    }

    /** Start the wizard in a <em>modal</em> dialog */
    public void actionPerformed( ActionEvent arg0 ) {
        wiz.showWizard( null, "Installer Wizard", true );
    }

    protected void leavingPage( JComponent from, boolean usingNext ) {
        System.out.println( "--- Leaving page " + from );
    }

    protected void leavingWizard( boolean successful ) {
        System.out.print( "--- Leaving wizard " + this + ": " );
        if( successful )
            System.out.println( "finished" );
        else
            System.out.println( "canceled" );
        
        Enumeration keys = keys();
        while( keys.hasMoreElements() ) {
            String key = (String) keys.nextElement();
            String value = (String) get( key );
            System.out.println( ">>> " + key + "=" + value );
        }
    }
    
    /** 
     * Put up a toplevel frame with a button which will start
     * the wizard.
     */
    public static void main( String[] args ) throws InterruptedException {

        wiz = new InstallerWizard();
        JButton button = new JButton( "Go!" );
        button.addActionListener( wiz );

        JFrame frame = new JFrame( "Go!" );
        frame.getContentPane().add( button );
        frame.setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
        frame.pack();
        frame.setVisible( true );
    }
}
