package org.eso.ohs.instruments;

/**
 * This is a parameter class which stores the path
 * of a file stored on disk.
 * <p>
 *
 * $Id: FileParameter.java,v 1.8 2003/06/15 13:19:15 tcanavan Exp $
 * @author Tim Canavan
 */

public class FileParameter extends Parameter {

    static final long serialVersionUID = -6979095492039942596L;

    /**
     * Constructor
     * @param parameterName name of parameter
     */

    public FileParameter(ParamMetaData pMeta) {
        super(pMeta);
    }

    /**
     * Return tooltip text for Filename parameter
     */

    public String getToolTipText() {
         return "<Left Mouse Click> to Select file\n<Shift-Left Mouse Click> to Save file";
      
    }

    public char getDBTypeCode() {
        return 'f';
    }


    /**
     * Verify that the filename is valid
     * @param s filename 
     */
    
    public boolean verifyValue(String s) {
         if(s.equals("NODEFAULT"))
             return false;
         return true;
    }
}
