package org.eso.ohs.instruments;

import java.util.List;
import java.util.Vector;

import org.jdom.Element;

/**
 * 
 * Class ReadmeAttribComparison
 *
 * TODO Javadoc
 *
 * @version $Revision: 1.8 $
 * @author tcanavan, Nov 17, 2004
 */

// $Id: ReadmeAttribComparison.java,v 1.8 2004/12/15 07:02:15 tcanavan Exp $
 

public class ReadmeAttribComparison {

    public static AttribComparison[] compareAttributes(
            ReadmeAttribute[] readmeAttribute, List list) {
        Vector vec = new Vector();
        for (int i = 0; i < readmeAttribute.length;i++) {
            String name = readmeAttribute[i].getName();
            String newValue = readmeAttribute[i].getValue();
            String superType = readmeAttribute[i].getReadmeConfig().getSuperType();
            String label = readmeAttribute[i].getReadmeConfig().getLabel();
            boolean found=false;
            for(int j=0;j<list.size();j++) {
                Element elm = (Element) list.get(j);
                boolean attribChanged=false;
                if (elm.getName().equals(name)) {
                    found = true;
                    List dataList = elm.getChildren();
                    Element elmData = (Element)dataList.get(1);
                    String oldValue = elmData.getText().trim();
                    if (!oldValue.equals(newValue)) {
                        AttribComparison attComp = new AttribComparison();
                        attComp.setName(name);
                        attComp.setOldValue(oldValue);
                        attComp.setNewValue(newValue);
                        attComp.setLabel(label);
                        attComp.setDBType(ReadmeAttributesFactory.getDbType(superType));
                        attComp.setStatus(AttribComparison.ATTRIB_CHANGED);
                        vec.addElement(attComp);
                    }
                }     
            }
            if (!found) {
                // Attribute has been Addeded
                AttribComparison attComp = new AttribComparison();
                attComp.setName(name);
                attComp.setOldValue("");
                attComp.setNewValue(newValue);
                attComp.setStatus(AttribComparison.ATTRIB_ADDED);
                attComp.setDBType(ReadmeAttributesFactory.getDbType(superType));
                vec.addElement(attComp);
            }
        }
        for (int i = 0; i < list.size(); i++) {
            Element elm = (Element) list.get(i);
            boolean found = false;
            boolean attribChanged = false;
            for (int j = 0; j < readmeAttribute.length; j++) {
                String name = readmeAttribute[j].getName();
                if (elm.getName().equals(name)) {
                    found = true;
                }
            }
            if (!found) {
                // Attribute has been Discarded
                AttribComparison attComp = new AttribComparison();
                attComp.setName(elm.getName());
                attComp.setOldValue(elm.getText());
                attComp.setStatus(AttribComparison.ATTRIB_DISCARDED);
                vec.addElement(attComp);
            }
        }
        AttribComparison[] comp = new AttribComparison[vec.size()];
        vec.copyInto(comp);
        return comp;

    }

}