package org.eso.ohs.phase2.apps.masktracker.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.phase2.apps.masktracker.MaskBrowser;
import org.eso.ohs.phase2.apps.ot.gui.OTMainView;

/**
 * Action class to display the contents of the database.
 *
 * <p>
 * $Id: ShowMaskDbaseAction.java,v 1.2 2005/02/11 10:31:50 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */

public class ShowMaskDbaseAction extends ActionSuperclass {

   /** Standard log channel */
   private static Logger stdlog_ =
       Logger.getLogger( ShowMaskDbaseAction.class );

    /**
     * Constructs a ShowDbaseAction action.
     */
    public ShowMaskDbaseAction(OTMainView mwdw) {
	super(mwdw, "Mask Browser");
    }

    /**
     * Event handler for the ShowDbaseAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     */
    public void actionPerformedImpl(ActionEvent evt) {
	JFrame frm;

	

	try {
	    frm = MaskBrowser.getDbaseWindow();
            frm.pack(); 
	    frm.show();
	}
	catch (ObjectIOException e) {
	    // announceIOError(e);
	    stdlog_.error(e);	// Info for ESO User Support.
	    JOptionPane.showMessageDialog(
		null,
		new Object[] {
		    "Your objects in the ESO database could not be displayed.",
		    "This is usually because the server at ESO"
			+ " cannot be contacted"
			+ " for some reason.",
		    " ",
		    "Check your Internet connection to ESO"
			+ " and try again.",
		    "If error persists, contact ESO User Support.",
		},
		"Connection Error",
		JOptionPane.WARNING_MESSAGE
	    );
	}
    }

}


