package org.eso.ohs.phase2.apps.ot.actions;

import java.awt.Component;
import java.awt.event.ActionEvent;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import org.apache.log4j.Logger;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.widgets.SimpleInputDialog;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.dfs.Queue;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.phase2.apps.ot.gui.OTViewManager;
import org.eso.ohs.phase2.apps.ot.gui.QueueContainer;
import org.eso.ohs.phase2.apps.ot.gui.QueueView;

/**
 * Action class to create a subdirectory of the selected directory.
 *
 * <p>
 * $Id: SaveQueueAction.java,v 1.12 2005/02/11 10:31:49 tcanavan Exp $
 * <br>
 * Author: Bob Kemp
 */
public class SaveQueueAction extends ActionSuperclass {


   /** Standard log channel */
   private static Logger stdlog_ =
       Logger.getLogger( SaveQueueAction.class );

    private QueueContainer queueContainer_;

    private JFrame parentFrame_;

    public SaveQueueAction(QueueContainer queueContainer, String name) {
	super(queueContainer.getParentFrame(),name);
        queueContainer_ = queueContainer;
	parentFrame_ = queueContainer.getParentFrame();
    }


  
   public void actionPerformedImpl(ActionEvent ev) {
       try {	
           ObjectManager objMgr = ObjectManager.getObjectManager();       
	   long [] queueIds = queueContainer_.getSelectedOpenQueueIds();
	   //Queue queue= (Queue)objMgr.getBusObj(Media.DBASE,
	   //					Config.getCfg().tableToUniqueId(queueIds[0],Queue.class),
	   //				Queue.class);

           System.out.println("Queue Ids " + queueIds[0]);
           Class c = Config.getCfg().getClassFromQueueId(queueIds[0]);
	   Queue queue= (Queue)objMgr.getBusObj(Media.DBASE,
						queueIds[0],
						c);
         
           QueueView qv = OTViewManager.getOTViewMgr().getQueueView(queue.getId());
           if(qv!=null)  
               qv.updateQueue();         
	   if(queue.isNew() && queue.getName().equals("No Name")) {
	       JTextField newNameTF = new JTextField();
	       SimpleInputDialog dlg = new SimpleInputDialog(
			    queueContainer_.getParentFrame(),
                            "Enter new name",
                            "",
                            new String[] { "New name:" },
                            new Component[] { newNameTF });
	       dlg.show();
	       if (dlg.getUserChoice() == JOptionPane.OK_OPTION) {
		   String name = newNameTF.getText();
		   if(name.length() <= 0) {
		       JOptionPane.showMessageDialog(
			     parentFrame_,
			     new Object[] {
			 	"Cannot save a queue with a name that "+
				"has no characters",
			     },
			     "Cannot save",
			     JOptionPane.ERROR_MESSAGE
			     );
		       return;
		   }
		   queue.setName(name);
	       }
	       else
		   return;	     	      
	   }
           if(queue.getStartTime() > Integer.MAX_VALUE){
               JOptionPane.showMessageDialog( parentFrame_,
                 new Object[] { "Start Time is not valid. ", }, 
                 "Cannot save", JOptionPane.ERROR_MESSAGE);
               return;
	   }
	   queue.setUpdate(false);
	   objMgr.putBusObj(queue);
	   queue.setIsNew(false);
	  
	}	
	catch (ObjectNotFoundException e) {
	    String message ="The following error occured while " +
		" saving the Queue: \n " + e.getMessage();
	    JOptionPane.showMessageDialog(null,message,"Error", 
				      JOptionPane.ERROR_MESSAGE);    
	    stdlog_.error(e);
	}

	catch (ObjectIOException e) {
        e.printStackTrace();
            String message ="The following error occured while " +
		" saving the Queue: \n " + e.getMessage();
            JOptionPane.showMessageDialog(null,message,"Error",
                                      JOptionPane.ERROR_MESSAGE);
            stdlog_.error(e);
	}      
   }
}

