package org.eso.ohs.phase2.apps.p2pp.actions;

import java.awt.event.ActionEvent;

import javax.swing.JFrame;

import org.eso.ohs.core.utilities.ObjUtils;
import org.eso.ohs.persistence.ObjectContainer;
import org.eso.ohs.persistence.ObjectManager;
import org.eso.ohs.phase2.actions.Stage2VerifyBOAction;

/**
 * Action class to perform stage 2 (EVM) verification
 * on the selected BusinessObjects.
 *
 * @author Nick Kornweibel
 */

public class P2PPStage2VerifyBOAction extends Stage2VerifyBOAction {

  

    public P2PPStage2VerifyBOAction(ObjectContainer folderView, boolean folder,String name) {
	super(folderView,folder,name);
    }

    /**
     * Event handler for the VerifyBOAction action.
     * 
     * @param ev       user-initiated ActionEvent to quit.
     * <br>ChangeLog: Toni Schlichting !! see document "item_0843.txt" accordingly
     */

    public void actionPerformedImpl(ActionEvent evt) {
	Long [] idLongs = null;
        numErrs = 0;
        numGood = 0;

	ObjectManager mMgr = ObjectManager.getObjectManager();
        msgLog = new StringBuffer();

        reportLog_.clearTextArea();
        reportLog_.setVisible(false);

        if (!folder_ ) {
            idLongs = folderView_.getAllSelected();
        } else {
            idLongs = folderView_.getAll();
        }

        idLongs = (Long[])ObjUtils.uniqueOccurrences(idLongs);	
        new P2PPIncrementalActionAutomaton(
            new IncrementalVerify(idLongs),
            (JFrame)folderView_.getTopLevelAncestor(), "Verifying ...");
    }    
}
