package org.eso.ohs.phase2.icdVcs;

import java.util.EventListener;

/**
 * Listener for events from the BOB interface
 * 
 * <p>
 * NOTE: This class must be public in order for Java/Ccs to work.
 *       I'm not sure of the reason but it's probably to do with
 *       their use of the Reflection API.
 * 
 * <p>
 * $Id: EventCmdListener.java,v 1.3 2003/07/03 08:49:49 ddorigo Exp $
 * <br>
 * @author Bob Kemp
 */
public interface EventCmdListener extends EventListener {

   /**
     * Handler method for ObsBlockStatus messages from BOB.
     * 
     * @param msg	    status message as a tcl array
     *
     */
    public void ObsBlockStatus(String id, String when, String what,
				String extraInfo);


    /**
     * Handler method for TemplateStatus messages from BOB.
     * 
     * @param msg	    status message as a tcl array
     */
    public void TemplateStatus(String id, String when, String what,
				String extraInfo);


    /**
     * Handler method for GetPAF messages from BOB.
     * 
     * @param reply	    Reply as a string, eg Mask Manufacturing Report.
     */
    public void GetPAFResult(String reply);

}


