package org.eso.ohs.phase2.visiplot;

/*
 * HeaderOptionsPanel.java
 *
 * Created on July 31, 2001, 1:26 PM
 *
 * @author Nick Kornweibel for ESO.
 */

import java.awt.BorderLayout;
import java.awt.GridLayout;

import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.border.TitledBorder;

public class HeaderOptionsPanel extends JPanel {

    private JPanel sortOrderPanel_;
    private JLabel sortOrderLabel_;
    private JComboBox sortOrderCombo_;
    private JPanel plotHeaderPanel_;
    private JCheckBox raCheck_;
    private JCheckBox seeingCheck_;
    private JCheckBox decCheck_;
    private JCheckBox fliCheck_;
    private JCheckBox progIdCheck_;
    private JCheckBox moonDistCheck_;
    private JCheckBox obIdCheck_;
    private JCheckBox skyCheck_;
    private JCheckBox rankClassCheck_;
    private JCheckBox execTimeCheck_;
    private JCheckBox startTimeCheck_;
    private JCheckBox airMassCheck_;

    /**
     * Creates new form HeaderOptionsPanel
     */

    public HeaderOptionsPanel() {
        initComponents ();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     */

    private void initComponents() {
        sortOrderPanel_  = new JPanel();
        sortOrderLabel_  = new JLabel();
        sortOrderCombo_  = new JComboBox();
        plotHeaderPanel_ = new JPanel();
        raCheck_         = new JCheckBox();
        seeingCheck_     = new JCheckBox();
        decCheck_        = new JCheckBox();
        fliCheck_        = new JCheckBox();
        airMassCheck_    = new JCheckBox();
        progIdCheck_     = new JCheckBox();
        moonDistCheck_   = new JCheckBox();
        obIdCheck_       = new JCheckBox();
        skyCheck_        = new JCheckBox();
        rankClassCheck_  = new JCheckBox();
        execTimeCheck_   = new JCheckBox();
        startTimeCheck_  = new JCheckBox();
        setLayout(new BorderLayout());

        sortOrderCombo_.addItem(VisiPlotOptions.sortByProgid);
        sortOrderCombo_.addItem(VisiPlotOptions.sortByObid);
        sortOrderCombo_.addItem(VisiPlotOptions.sortByRank);
        sortOrderCombo_.addItem(VisiPlotOptions.sortBySeeing);
        sortOrderCombo_.addItem(VisiPlotOptions.sortByFli);
        sortOrderCombo_.addItem(VisiPlotOptions.sortByMoondist);
        sortOrderCombo_.addItem(VisiPlotOptions.sortBySkytrans);
	sortOrderCombo_.setSelectedItem(VisiPlotOptions.defaultSortOrder);

        sortOrderLabel_.setText("Order reports by:");
        sortOrderPanel_.add(sortOrderLabel_);
        sortOrderPanel_.add(sortOrderCombo_);

        add(sortOrderPanel_, BorderLayout.NORTH);

        // setting num rows 0 for GridLayout - this forces the specified
        // columns (2) to be maintained.
        plotHeaderPanel_.setLayout(new GridLayout(0, 2, 5, 5));
        plotHeaderPanel_.setBorder(new TitledBorder("Report Header Text:"));

        raCheck_.setText("RA");
        plotHeaderPanel_.add(raCheck_);

        seeingCheck_.setText("seeing");
        plotHeaderPanel_.add(seeingCheck_);

        decCheck_.setText("DEC");
        plotHeaderPanel_.add(decCheck_);

        airMassCheck_.setText("air mass");
        plotHeaderPanel_.add(airMassCheck_);

        progIdCheck_.setText("program id");
        plotHeaderPanel_.add(progIdCheck_);

        fliCheck_.setText("frac. lunar illum.");
        plotHeaderPanel_.add(fliCheck_);

        obIdCheck_.setText("ob id");
        plotHeaderPanel_.add(obIdCheck_);

        moonDistCheck_.setText("moon distance");
        plotHeaderPanel_.add(moonDistCheck_);

        rankClassCheck_.setText("rank class");
        plotHeaderPanel_.add(rankClassCheck_);

        skyCheck_.setText("sky trans.");
        plotHeaderPanel_.add(skyCheck_);

        execTimeCheck_.setText("exec. time");
        plotHeaderPanel_.add(execTimeCheck_);

        startTimeCheck_.setText("start time");
        plotHeaderPanel_.add(startTimeCheck_);

        add(plotHeaderPanel_, BorderLayout.CENTER);
    }

    /**
     * set the raCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setRA(boolean en) {
        raCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getRA() {
        return raCheck_.isSelected();
    }

    /**
     * set the seeingCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setSeeing(boolean en) {
        seeingCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getSeeing() {
        return seeingCheck_.isSelected();
    }

    /**
     * set the decCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setDec(boolean en) {
        decCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getDec() {
        return decCheck_.isSelected();
    }

    /**
     * set the fliCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setFLI(boolean en) {
        fliCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getFLI() {
        return fliCheck_.isSelected();
    }

    /**
     * set the airMassCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setAirMass(boolean en) {
        airMassCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getAirMass() {
        return airMassCheck_.isSelected();
    }

    /**
     * set the progIdCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setProgId(boolean en) {
        progIdCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getProgId() {
        return progIdCheck_.isSelected();
    }

    /**
     * set the moonDistCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setMoonDistance(boolean en) {
        moonDistCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getMoonDistance() {
        return moonDistCheck_.isSelected();
    }

    /**
     * set the obIdCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setOBId(boolean en) {
        obIdCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getOBId() {
        return obIdCheck_.isSelected();
    }

    /**
     * set the skyCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setSkyTrans(boolean en) {
        skyCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getSkyTrans() {
        return skyCheck_.isSelected();
    }

    /**
     * set the rankClassCheck_ checkbox
     * @param true if the checkbox is to the selected
     */

    public void setRankClass(boolean en) {
        rankClassCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getRankClass() {
        return rankClassCheck_.isSelected();
    }

    /**
     * set the execTime checkbox
     * @param true if the checkbox is to the selected
     */

    public void setExecTime(boolean en) {
        execTimeCheck_.setSelected(en);
    }

    /**
     * set the startTime checkbox
     * @param true if the checkbox is to the selected
     */

    public void setStartTime(boolean en) {
        startTimeCheck_.setSelected(en);
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getExecTime() {
        return execTimeCheck_.isSelected();
    }

    /**
     * @return selected status of the checkbox
     */

    public boolean getStartTime() {
        return startTimeCheck_.isSelected();
    }

    /**
     * set the sort order - if the item specified in the param does not
     * exist in the list, the selection is not made.
     */

    public void setSortOrder(String order) {
		for (int i = 0; i < sortOrderCombo_.getItemCount(); i++) {
			if (((String)sortOrderCombo_.getItemAt(i)).equals(order)) {
				sortOrderCombo_.setSelectedItem(order);
				break;
			}
		}
    }

    /**
     * @return the selected item the list
     */

    public String getSortOrder() {
        return (String)sortOrderCombo_.getSelectedItem();
    }
	
    /**
     * Check all entries in the panel.
     * Sort order combo is set to the default entry if it is empty.
     * @return a report on the validity of the entries in the panel, ""
     * indicates that there is no problem with the entries.
     */	
	
	public String checkEntries() {
		if (getSortOrder() == null || getSortOrder().equals("")) {
			setSortOrder(VisiPlotOptions.defaultSortOrder);
		}
		return "";
	}
}
